@ECHO OFF

SETLOCAL EnableExtensions

SET UPDATE=%~dp0
SET INSTALL_FILE=%UPDATE%\WindowsSensorInstaller.exe

ECHO Welcome to Tetration Analytics Windows Sensor installation.
ECHO Please wait while installation is running.

:: Checking sensor install path
IF NOT "%~1"=="" (
   ECHO custom path is given
   ECHO sensor_base: %1
   :: A quick check to see if user are passing relative path
   ECHO %1 | findstr :\ 1>nul
   IF ERRORLEVEL 1 (
   ECHO must use absolute path, installation abort.
   EXIT /B 1
   )
   :: Check if folder already exist
   IF EXIST "%~1\" (
      ECHO %1\ already exist
   ) ELSE (
      ECHO %1 not exist, creating...
      MKDIR "%~1"
      IF ERRORLEVEL 1 (echo create folder failed, check if syntax is correct.
      ECHO Installation abort.
      EXIT /B 1
      ) ELSE (
         ECHO folder created SUCCESSFULLY
      )
   )
   ECHO sensor will be install at %1
) ELSE (
   ECHO argument1 not set, using default path
)

ECHO Checking if all dependencies are satisfied.

IF NOT EXIST "%INSTALL_FILE%" (
   ECHO Installation file %INSTALL_FILE% is missing, installation terminated.
   EXIT /B 1
)

ECHO Start installing Tetration Analytics Windows Sensor, please wait.

"%INSTALL_FILE%" /S /D=%~1

:: get base_path from registry
CALL :get_base_path
:: rename check update script
move "%BASE_PATH%\check_conf_update_new.cmd" "%BASE_PATH%\check_conf_update.cmd" > NUL

ECHO Windows Sensor installation completed.
ECHO You could now remove all the installation files.

ENDLOCAL

EXIT /B 0

:get_base_path
set KEY_NAME="HKEY_LOCAL_MACHINE\SOFTWARE\Tetration"
set VALUE_NAME=SensorPath
REG QUERY %KEY_NAME% /v %VALUE_NAME% > NUL
for /f "usebackq skip=2 tokens=2,*" %%A IN (`REG QUERY %KEY_NAME% /v %VALUE_NAME%`) DO (
    set BASE_PATH=%%B
)
